from os import path
from setuptools import setup, find_packages

here = path.abspath(path.dirname(__file__))

with open(path.join(here, 'README.md')) as f:
    readme = f.read()

setup(
    name="deep-confusables",
    version="1.1.0",
    packages=find_packages(),
    long_description=readme,
    long_description_content_type='text/markdown',
    description=('deep-confusables - cli generates new variations of an input based on '
                 'similarity matrix generated by deep-confusables-similarity.'),
    author="José Ignacion Escribano & Miguel Hernández & Alfonso Muñoz",
    author_email="deep.confusables@gmail.com",
    url="https://github.com/next-security-lab/deep-confusables-cli",
    license="MIT",
    python_requires='>3.5.0',
    install_requires=[
        'tqdm',
        'colorama',
        'python-whois',
        'requests',
        'virustotal-api'
    ],
    extras_require={
        'dev': [
            'flake8'
        ]
    },
    entry_points={
        'console_scripts': [
            'deep-confusables = deep_confusables.main:main',
        ]
    },
    classifiers=[
        'Environment :: Console',
        'Intended Audience :: System Administrators',
        'Intended Audience :: Other Audience',
        'License :: OSI Approved :: BSD License',
        'Operating System :: MacOS',
        'Operating System :: Microsoft :: Windows',
        'Operating System :: POSIX',
        'Programming Language :: Python :: 3',
    ],
    )
